/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.ejaservlets;

import cz.cvut.kbss.ejaservlets.support.CaesarCipher;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Jednoduchy priklad na servlety - servlet sifrujici zadany text pomoci Caesarovy sifry
 * 
 * Vsimnete si, ze zde servlet mapujeme pomoci anotaci. Servlet se bude jmenovat
 * "CaesarCipherServlet" a bude se nachazet na ceste relativni ke kontextu "/CaesarCipherServlet"
 * 
 * Pri mapovani pomoci anotaci v Java EE 6 nepotrebujeme soubor web.xml (ktery je nepovinny),
 * ale ve vetsine pripadu se mu stejne nemame sebemensi sanci vyhnout.
 * 
 * ----------------
 * V realnem svete by byly CSS styly v externim stylopisu, byl by zde doctype a 
 * sifrovaci a desifrovaci servlety by dedily ze spolecneho predka, protoze si jsou
 * dosti podobne
 * 
 * @author Pavel Micka
 */
@WebServlet(name = "CaesarCipherServlet", urlPatterns = {"/CaesarCipherServlet"})
public class CaesarCipherEncryptionServlet extends HttpServlet {

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            String toEncrypt = request.getParameter("openText");


            out.println("<html>");
            out.println("  <head>");
            out.println("    <title>Šifrování pomocí Caesarovy šifry</title>");
            out.println("  </head>");
            out.println("  <body>");
            out.println("    <h1>Šifrování pomocí Caesarovy šifry</h1>");
            out.println("    <form method=\"post\" action=\"CaesarCipherServlet\">");
            out.println("      <label for=\"text\">Zadejte prosím šifrovaný text (A-Z)</label>");
            out.println("      <input type=\"text\" id=\"text\" name=\"openText\" value=\"\">");
            out.println("      <input type=\"submit\">");
            out.println("    </form>");
            try {
                if (toEncrypt != null) {
                    String result = CaesarCipher.encipher(toEncrypt);
                    request.getSession().setAttribute("cipherText", result);
                    out.println("    <div>Šifrovaný text: " + result + "</div>");
                }
            } catch (IllegalArgumentException ex) {
                out.println("    <div style=\"color: red;\">Neplatný formát vstupu: " + toEncrypt + "</div>");
            }
            out.print("    <div style=\"margin-top: 2em; padding-top: 1em; border-top: 1px dashed black\"><a href=\"CaesarCipherDecryptionServlet\">Přejít k dešifrování</a></div>");
            out.println("  </body>");
            out.println("</html>");
        } finally {
            out.close();
        }
    }

    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Caesar cypher encryption servlet";
    }
}
