<%@page import="java.text.DateFormat"%>
<%@page import="java.util.Date"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Skriptovací značky</title>
        <link rel="stylesheet" href="resources/css/znacky.css"></link>
    </head>
    <body>
        <h1>Skriptovací značky</h1>
        <p>Kromě šablonovací knihovny JSTL, poskytující např. tagy pro řízení toku (for each, if...)
            a formátovací tagy (datum, čas...), lze v JSP používat i skriptovací značky.
        </p>
        <h2>Vyhodnocení výrazu</h2>
        <p>Nejjednodušší variantou je vyhodnocení výrazu - značka: <strong>&lt;%= %></strong>, kterou můžeme využít například následujícím způsobem (překládá se do výstupu servletu):
            <strong>&lt;%= DateFormat.getDateInstance().format(new Date())%></strong> (importy se musí nacházet v hlavičce šablony), což nám vrátí "<%= DateFormat.getDateInstance().format(new Date())%>".
            V tomto případě by patrně ale bylo přirozenější (a čitelnější) zapsat daný výraz kombinací JSTL a skriptovací značky.
        </p>
        <code>
            &lt;fmt:formatDate value="&lt;%= new Date() %>" />
        </code>
        <p>Značka vyhodnocení výrazu může velmi zjednodušit práci s šablonou, jelikož není nutné předávat zbytečné atributy.</p>

        <h2>Skriptlety</h2>
        <p>
            Poněkud těžkotonážnější zbraní jsou skriptlety - sekvence příkazů Javy přímo v JSP šabloně (značka <strong>&lt;% %></strong>). Skriptlety se překládají do těla metody servletu <em>_jspService()</em>. Skriptletům se za určitých okolností nelze vyhnout (vyžadujeme funkcionalitu, kterou JSTL nepodporuje). Zde je však čistější pro tuto funkčnost vytvořit vlastní uživatelský tag.
        </p>

        <p>
            Ač pokušení může být veliké, tak mějme na paměti, že bychom nikdy neměli v JSP stránce mít žádnou logiku (ta nepatří do šablony, ale do řadiče) a v žádném případě bychom nikdy neměli z JSP stránky sahat přímo do databáze.
            Představme si, že bychom toto dělali a posléze se rozhodli, že nebudeme používat MySQL, ale PostgreSQL - pak bychom museli zasahovat do
            všech stránek (tj. do zcela nesouvisející technologie) a na všech místech upravit volání. Kdybychom tuto logiku měli zabalenou ve speciálních DAO objektech (data access object), tak v nich pouze upravíme pár řádek a za 10 minut je DB nahrazena.
        </p>
        <code>
            <pre>
&lt;% 
    int number = 5;

    int result = 1;
    for (int i = number; i > 1; i--) {
        result *= i;
    }        
    out.print(result);
%>
            </pre>
        </code>
        Výstup (faktoriál čísla 5): <%
            int number = 5;

            int result = 1;
            for (int i = number; i > 1; i--) {
                result *= i;
            }
            out.print(result);
        %>
        <h2>Deklarace</h2>
        <p>Ještě o stupínek dál jsou deklarace (<strong>&lt;%! %></strong>), které umožňují vytváření metod v JSP stránce. Výhrady vůči nim jsou totožné jako skriptletů - vedou na duplikaci kódu mezi několika JSP stránkami a umožňují dělat volání, která jdou zcela proti duchu jakékoliv komplexnější architektury. Deklarace se do servletu překládají jako samostatné metody.</p>
        <code>
            <pre>
&lt;%!            
public int factorial(int number) {

        int result = 1;
        for (int i = number; i > 1; i--) {
            result *= i;
        }

        return result;
    }
%>  
            </pre>
        </code>   
    </body>
</html>
